---
# Makes daily backups of data, only needed on the delegate server.
#
# TODO: Notify when backups fail :O

- name: borg ssh key
  when: "inventory_hostname == delegate.hostname"
  openssh_keypair:
    type: ed25519
    path: "{{ root }}/id_ed25519"

- name: borg pub key
  when: "inventory_hostname == delegate.hostname"
  fetch:
    dest: ./backup
    src: "{{ root }}/id_ed25519.pub"

# XXX: Ansible doesn't seem to notice changes in the local file
# TODO: We don't have a way to fetch the backup server host key
- name: borg known hosts
  when: "inventory_hostname == delegate.hostname"
  known_hosts:
    state: present
    path: "{{ root }}/borg_known_hosts"
    hash_host: yes
    name: "{{ backups.ssh.server }}"
    key: "{{ backups.ssh.server }} {{ lookup('file', './ssh/{{ backups.ssh.server }}/etc/ssh/ssh_host_ed25519_key.pub') }}"

- name: borg container
  when: "inventory_hostname == delegate.hostname"
  docker_container:
    name: borg
    image: "{{ registry }}/sutty/borg:3.15.0"
    restart_policy: always
    pull: yes
    detach: yes
    state: started
    hostname: "borg.{{ inventory_hostname }}"
    dns_search_domains: "{{ inventory_hostname }}"
    volumes:
    - "/dev/log:/dev/log"
    - "{{ root }}:/srv/data"
    - "{{ root }}/borg_known_hosts:/root/.ssh/known_hosts"
    env:
      EMAIL: "{{ monit.email }}"
      EMAIL_FROM: "{{ monit.email_from }}"
      DOMAIN: "{{ inventory_hostname }}"
      MMONIT: "mmmonit.{{ delegate.hostname }}:3000"
      CREDENTIALS: "{{ lookup('community.general.random_string', length=12, special=false) }}:{{ lookup('community.general.random_string', length=12, special=false) }}"
      BORG_PASSPHRASE: "{{ vault.backups }}"
      DEST: "{{ backups.dest }}"
      SSH_ALIAS: "{{ backups.ssh.alias }}"
      SSH_SERVER: "{{ backups.ssh.server }}"
      SSH_USER: "{{ backups.ssh.user }}"
      SSH_PORT: "{{ backups.ssh.port }}"
      KEEP: "{{ backups.keep }}"
    networks:
    - name: sutty
    purge_networks: yes
    tmpfs:
    - /tmp
    - /run

- name: borg container
  when: "inventory_hostname != delegate.hostname"
  docker_container:
    name: borg
    detach: yes
    state: absent
